package net.minecraft.client;

import java.awt.Point;
import java.awt.MouseInfo;
import org.lwjgl.input.Mouse;
import java.nio.IntBuffer;
import org.lwjgl.LWJGLException;
import org.lwjgl.BufferUtils;
import java.awt.AWTException;
import org.lwjgl.input.Cursor;
import java.awt.Robot;
import java.awt.Component;

public final class MouseHelper {
    private Component windowComponent;
    private Robot robot;
    private int mouseX;
    private int mouseY;
    private Cursor cursor;
    public int deltaX;
    public int deltaY;
    private int mouseInt;
    
    public MouseHelper(final Component component) {
        this.mouseInt = 10;
        this.windowComponent = component;
        try {
            this.robot = new Robot();
        }
        catch (AWTException ex) {
            ex.printStackTrace();
        }
        final IntBuffer intBuffer;
        (intBuffer = BufferUtils.createIntBuffer(1)).put(0);
        intBuffer.flip();
        final IntBuffer intBuffer2 = BufferUtils.createIntBuffer(1024);
        try {
            this.cursor = new Cursor(32, 32, 16, 16, 1, intBuffer2, intBuffer);
        }
        catch (LWJGLException ex2) {
            ex2.printStackTrace();
        }
    }
    
    public final void grabMouseCursor() {
        try {
            Mouse.setNativeCursor(this.cursor);
        }
        catch (LWJGLException ex) {
            ex.printStackTrace();
        }
        this.ungrabMouseCursor();
        this.deltaX = 0;
        this.deltaY = 0;
    }
    
    public final void ungrabMouseCursor() {
        final Point location = MouseInfo.getPointerInfo().getLocation();
        final Point locationOnScreen = this.windowComponent.getLocationOnScreen();
        this.robot.mouseMove(this.mouseX, this.mouseY);
        this.mouseX = locationOnScreen.x + this.windowComponent.getWidth() / 2;
        this.mouseY = locationOnScreen.y + this.windowComponent.getHeight() / 2;
        if (this.mouseInt == 0) {
            this.deltaX = location.x - this.mouseX;
            this.deltaY = location.y - this.mouseY;
            return;
        }
        final int n = 0;
        this.deltaY = n;
        this.deltaX = n;
        --this.mouseInt;
    }
}
