package net.minecraft.client.gui;

import net.minecraft.client.renderer.RenderEngine;
import org.lwjgl.opengl.GL11;
import net.minecraft.client.inventory.IInventory;
import net.minecraft.client.inventory.InventoryCraftResult;
import net.minecraft.game.entity.player.InventoryPlayer;
import net.minecraft.game.block.tileentity.TileEntityFurnace;

public final class GuiFurnace extends GuiContainer {
    private TileEntityFurnace furnaceInventory;
    
    public GuiFurnace(final InventoryPlayer playerInventory, final TileEntityFurnace furnace) {
        new InventoryCraftResult();
        this.furnaceInventory = furnace;
        this.inventorySlots.add(new Slot(this, furnace, 0, 56, 17));
        this.inventorySlots.add(new Slot(this, furnace, 1, 56, 53));
        this.inventorySlots.add(new Slot(this, furnace, 2, 116, 35));
        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 9; ++j) {
                this.inventorySlots.add(new Slot(this, playerInventory, j + (i + 1) * 9, 8 + j * 18, 84 + i * 18));
            }
        }
        for (int i = 0; i < 9; ++i) {
            this.inventorySlots.add(new Slot(this, playerInventory, i, 8 + i * 18, 142));
        }
    }
    
    @Override
    protected final void drawGuiContainerForegroundLayer() {
        this.fontRenderer.drawString("Furnace", 60, 6, 4210752);
        this.fontRenderer.drawString("Inventory", 8, this.ySize - 96 + 2, 4210752);
    }
    
    @Override
    protected final void drawGuiContainerBackgroundLayer() {
        int texture = this.mc.renderEngine.getTexture("/gui/furnace.png");
        GL11.glColor4d(1.0f, 1.0f, 1.0f, 1.0f);
        RenderEngine.bindTexture(texture);
        texture = (this.width - this.xSize) / 2;
        final int integer2 = (this.height - this.ySize) / 2;
        this.drawTexturedModalRect(texture, integer2, 0, 0, this.xSize, this.ySize);
        if (this.furnaceInventory.isBurning()) {
            final int n = this.furnaceInventory.getBurnTimeRemainingScaled(12);
            this.drawTexturedModalRect(texture + 56, integer2 + 36 + 12 - n, 176, 12 - n, 14, n + 2);
        }
        final int n = this.furnaceInventory.getCookProgressScaled(24);
        this.drawTexturedModalRect(texture + 79, integer2 + 34, 176, 14, n + 1, 16);
    }
}
