package net.minecraft.client.gui;

public final class GuiIngameMenu extends GuiScreen {
    @Override
    public final void initGui() {
        this.controlList.clear();
        this.controlList.add(new GuiButton(0, this.width / 2 - 100, this.height / 4, "Options..."));
        this.controlList.add(new GuiButton(1, this.width / 2 - 100, this.height / 4 + 24, "Generate new level..."));
        this.controlList.add(new GuiButton(2, this.width / 2 - 100, this.height / 4 + 48, "Save level.."));
        this.controlList.add(new GuiButton(3, this.width / 2 - 100, this.height / 4 + 72, "Load level.."));
        this.controlList.add(new GuiButton(4, this.width / 2 - 100, this.height / 4 + 120, "Back to game"));
        if (this.mc.session == null) {
            ((GuiButton)this.controlList.get(2)).enabled = false;
            ((GuiButton)this.controlList.get(3)).enabled = false;
        }
    }
    
    @Override
    protected final void actionPerformed(final GuiButton r) {
        if (r.id == 0) {
            this.mc.displayGuiScreen(new GuiOptions(this, this.mc.gameSettings));
        }
        if (r.id == 1) {
            this.mc.displayGuiScreen(new GuiLevelType(this));
        }
        if (this.mc.session != null) {
            if (r.id == 2) {
                this.mc.displayGuiScreen(new GuiSaveLevelScreen(this));
            }
            if (r.id == 3) {
                this.mc.displayGuiScreen(new GuiLoadLevelScreen(this));
            }
        }
        if (r.id == 4) {
            this.mc.displayGuiScreen(null);
            this.mc.setIngameFocus();
        }
    }
    
    @Override
    public final void drawScreen(final int xSize_lo, final int ySize_lo, final double double3) {
        this.drawDefaultBackground();
        Gui.drawCenteredString(this.fontRenderer, "Game menu", this.width / 2, 40, 16777215);
        super.drawScreen(xSize_lo, ySize_lo, double3);
    }
}
