package net.minecraft.client.gui;

import org.lwjgl.input.Keyboard;

public final class GuiLevelNameScreen extends GuiScreen {
    private GuiScreen parent;
    private String title;
    private int id;
    private String name;
    private int counter;
    
    public GuiLevelNameScreen(final GuiScreen i, final String name, final int id) {
        this.title = "Enter level name:";
        this.counter = 0;
        this.parent = i;
        this.id = id;
        this.name = name;
        if (this.name.equals("-")) {
            this.name = "";
        }
    }
    
    @Override
    public final void initGui() {
        this.controlList.clear();
        Keyboard.enableRepeatEvents(true);
        this.controlList.add(new GuiButton(0, this.width / 2 - 100, this.height / 4 + 120, "Save"));
        this.controlList.add(new GuiButton(1, this.width / 2 - 100, this.height / 4 + 144, "Cancel"));
        ((GuiButton)this.controlList.get(0)).enabled = (this.name.trim().length() > 1);
    }
    
    @Override
    public final void onGuiClosed() {
        Keyboard.enableRepeatEvents(false);
    }
    
    @Override
    public final void updateScreen() {
        ++this.counter;
    }
    
    @Override
    protected final void actionPerformed(final GuiButton r) {
        if (!r.enabled) {
            return;
        }
        if (r.id == 0 && this.name.trim().length() > 1) {
            this.name.trim();
            this.mc.displayGuiScreen(null);
            this.mc.setIngameFocus();
        }
        if (r.id == 1) {
            this.mc.displayGuiScreen(this.parent);
        }
    }
    
    @Override
    protected final void keyTyped(final char character, final int integer) {
        if (integer == 14 && this.name.length() > 0) {
            this.name = this.name.substring(0, this.name.length() - 1);
        }
        if ("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 ,.:-_'*!\"#%/()=+?[]{}<>".indexOf((int)character) >= 0 && this.name.length() < 64) {
            this.name += character;
        }
        ((GuiButton)this.controlList.get(0)).enabled = (this.name.trim().length() > 1);
    }
    
    @Override
    public final void drawScreen(final int xSize_lo, final int ySize_lo, final double double3) {
        this.drawDefaultBackground();
        Gui.drawCenteredString(this.fontRenderer, this.title, this.width / 2, 40, 16777215);
        final int xCoordLeft = this.width / 2 - 100;
        final int yCoordUp = this.height / 2 - 10;
        Gui.drawRect(xCoordLeft - 1, yCoordUp - 1, xCoordLeft + 200 + 1, yCoordUp + 20 + 1, -6250336);
        Gui.drawRect(xCoordLeft, yCoordUp, xCoordLeft + 200, yCoordUp + 20, -16777216);
        Gui.drawString(this.fontRenderer, this.name + ((this.counter / 6 % 2 == 0) ? "_" : ""), xCoordLeft + 4, yCoordUp + 6, 14737632);
        super.drawScreen(xSize_lo, ySize_lo, double3);
    }
}
