package net.minecraft.client.gui;

public final class GuiLevelType extends GuiScreen {
    private GuiScreen prevGui;
    private String[] worldType;
    private String[] worldShape;
    private String[] worldSize;
    private String[] worldTheme;
    private int selectedWorldType;
    private int selectedWorldShape;
    private int selectedWorldSize;
    private int selectedWorldTheme;
    
    public GuiLevelType(final GuiScreen i) {
        this.worldType = new String[] { "Inland", "Island", "Doubleing", "Flat" };
        this.worldShape = new String[] { "Square", "Long", "Deep" };
        this.worldSize = new String[] { "Small", "Normal", "Huge" };
        this.worldTheme = new String[] { "Normal", "Hell", "Paradise", "Woods" };
        this.selectedWorldType = 1;
        this.selectedWorldShape = 0;
        this.selectedWorldSize = 1;
        this.selectedWorldTheme = 0;
        this.prevGui = i;
    }
    
    @Override
    public final void initGui() {
        this.controlList.clear();
        this.controlList.add(new GuiButton(0, this.width / 2 - 100, this.height / 4, "Type: "));
        this.controlList.add(new GuiButton(1, this.width / 2 - 100, this.height / 4 + 24, "Shape:"));
        this.controlList.add(new GuiButton(2, this.width / 2 - 100, this.height / 4 + 48, "Size: "));
        this.controlList.add(new GuiButton(3, this.width / 2 - 100, this.height / 4 + 72, "Theme: "));
        this.controlList.add(new GuiButton(4, this.width / 2 - 100, this.height / 4 + 96 + 12, "Create"));
        this.controlList.add(new GuiButton(5, this.width / 2 - 100, this.height / 4 + 120 + 12, "Cancel"));
        this.worldOptions();
    }
    
    private void worldOptions() {
        ((GuiButton)this.controlList.get(0)).displayString = "Type: " + this.worldType[this.selectedWorldType];
        ((GuiButton)this.controlList.get(1)).displayString = "Shape: " + this.worldShape[this.selectedWorldShape];
        ((GuiButton)this.controlList.get(2)).displayString = "Size: " + this.worldSize[this.selectedWorldSize];
        ((GuiButton)this.controlList.get(3)).displayString = "Theme: " + this.worldTheme[this.selectedWorldTheme];
    }
    
    @Override
    protected final void actionPerformed(final GuiButton r) {
        if (r.id == 5) {
            this.mc.displayGuiScreen(this.prevGui);
        }
        else if (r.id == 4) {
            this.mc.generateLevel(this.selectedWorldSize, this.selectedWorldShape, this.selectedWorldType, this.selectedWorldTheme);
            this.mc.displayGuiScreen(null);
        }
        else if (r.id == 0) {
            this.selectedWorldType = (this.selectedWorldType + 1) % this.worldType.length;
        }
        else if (r.id == 1) {
            this.selectedWorldShape = (this.selectedWorldShape + 1) % this.worldShape.length;
        }
        else if (r.id == 2) {
            this.selectedWorldSize = (this.selectedWorldSize + 1) % this.worldSize.length;
        }
        else if (r.id == 3) {
            this.selectedWorldTheme = (this.selectedWorldTheme + 1) % this.worldTheme.length;
        }
        this.worldOptions();
    }
    
    @Override
    public final void drawScreen(final int xSize_lo, final int ySize_lo, final double double3) {
        this.drawDefaultBackground();
        Gui.drawCenteredString(this.fontRenderer, "Generate new level", this.width / 2, 40, 16777215);
        super.drawScreen(xSize_lo, ySize_lo, double3);
    }
}
