package net.minecraft.client.gui;

import java.io.IOException;
import java.io.OutputStream;
import net.minecraft.client.PlayerLoader;
import java.io.FileOutputStream;
import java.io.File;
import java.awt.Dialog;
import java.awt.FileDialog;

public final class GuiSaveLevelScreen extends GuiLoadLevelScreen {
    public GuiSaveLevelScreen(final GuiScreen i) {
        super(i);
        this.title = "Save level";
    }
    
    @Override
    protected final FileDialog saveFileDialog() {
        return new FileDialog((Dialog)null, "Save level", 1);
    }
    
    @Override
    public final void initGui() {
        super.initGui();
        ((GuiButton)this.controlList.get(5)).displayString = "Save file...";
    }
    
    @Override
    protected final void setLevels(final String[] arr) {
        for (int i = 0; i < 5; ++i) {
            ((GuiButton)this.controlList.get(i)).displayString = arr[i];
            ((GuiButton)this.controlList.get(i)).visible = true;
        }
        ((GuiButton)this.controlList.get(5)).visible = true;
    }
    
    @Override
    protected final void openLevel(final File file) {
        try {
            final FileOutputStream outputStream = new FileOutputStream(file);
            new PlayerLoader(this.mc, this.mc.loadingScreen).save(this.mc.theWorld, (OutputStream)outputStream);
            outputStream.close();
        }
        catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    @Override
    protected final void openLevel(final int integer) {
        this.mc.displayGuiScreen(new GuiLevelNameScreen(this, ((GuiButton)this.controlList.get(integer)).displayString, integer));
    }
}
