package net.minecraft.client.inventory;

import net.minecraft.game.item.ItemStack;

public final class InventoryCraftResult implements IInventory {
    private ItemStack[] stackResult;
    
    public InventoryCraftResult() {
        this.stackResult = new ItemStack[1];
    }
    
    public final int getSizeInventory() {
        return 1;
    }
    
    public final ItemStack getStackInSlot(final int integer) {
        return this.stackResult[integer];
    }
    
    public final String getInvName() {
        return "Result";
    }
    
    public final ItemStack decrStackSize(final int integer1, final int integer2) {
        if (this.stackResult[integer1] != null) {
            final ItemStack itemStack = this.stackResult[integer1];
            this.stackResult[integer1] = null;
            return itemStack;
        }
        return null;
    }
    
    public final void setInventorySlotContents(final int integer, final ItemStack itemStack) {
        this.stackResult[integer] = itemStack;
    }
    
    public final int getInventoryStackLimit() {
        return 64;
    }
}
