package net.minecraft.client.model;

import net.minecraft.game.MathHelper;

public class ModelZombie extends ModelBiped {
    @Override
    public final void setRotationAngles(double limbAngle, double animationSpeed, final double double3, final double headYaw, final double headPitch, final double double6) {
        super.setRotationAngles(limbAngle, animationSpeed, double3, headYaw, headPitch, double6);
        limbAngle = MathHelper.sin(0.0f);
        animationSpeed = MathHelper.sin(0.0f);
        this.bipedRightArm.rotateAngleZ = 0.0f;
        this.bipedLeftArm.rotateAngleZ = 0.0f;
        this.bipedRightArm.rotateAngleY = -(0.1f - limbAngle * 0.6f);
        this.bipedLeftArm.rotateAngleY = 0.1f - limbAngle * 0.6f;
        this.bipedRightArm.rotateAngleX = -1.5707964f;
        this.bipedLeftArm.rotateAngleX = -1.5707964f;
        final ModelRenderer bipedRightArm = this.bipedRightArm;
        bipedRightArm.rotateAngleX -= limbAngle * 1.2f - animationSpeed * 0.4f;
        final ModelRenderer bipedLeftArm = this.bipedLeftArm;
        bipedLeftArm.rotateAngleX -= limbAngle * 1.2f - animationSpeed * 0.4f;
        final ModelRenderer bipedRightArm2 = this.bipedRightArm;
        bipedRightArm2.rotateAngleZ += MathHelper.cos(double3 * 0.09f) * 0.05f + 0.05f;
        final ModelRenderer bipedLeftArm2 = this.bipedLeftArm;
        bipedLeftArm2.rotateAngleZ -= MathHelper.cos(double3 * 0.09f) * 0.05f + 0.05f;
        final ModelRenderer bipedRightArm3 = this.bipedRightArm;
        bipedRightArm3.rotateAngleX += MathHelper.sin(double3 * 0.067f) * 0.05f;
        final ModelRenderer bipedLeftArm3 = this.bipedLeftArm;
        bipedLeftArm3.rotateAngleX -= MathHelper.sin(double3 * 0.067f) * 0.05f;
    }
}
