package net.minecraft.client.model;

import net.minecraft.client.renderer.Vec3D;

public final class PositionTextureVertex {
    public Vec3D vector3D;
    public double texturePositionX;
    public double texturePositionY;
    
    public PositionTextureVertex(final double double1, final double double2, final double double3, final double double4, final double double5) {
        this(new Vec3D(double1, double2, double3), double4, double5);
    }
    
    public final PositionTextureVertex setTexturePosition(final double double1, final double double2) {
        return new PositionTextureVertex(this, double1, double2);
    }
    
    private PositionTextureVertex(final PositionTextureVertex positionTextureVertex, final double double2, final double double3) {
        this.vector3D = positionTextureVertex.vector3D;
        this.texturePositionX = double2;
        this.texturePositionY = double3;
    }
    
    private PositionTextureVertex(final Vec3D vec3D, final double double2, final double double3) {
        this.vector3D = vec3D;
        this.texturePositionX = double2;
        this.texturePositionY = double3;
    }
}
