package net.minecraft.client.particle;

import net.minecraft.game.block.Material;
import net.minecraft.game.level.World;

public final class EntityBubbleFX extends EntityFX {
    public EntityBubbleFX(final World world, final double double2, final double double3, final double double4, final double double5, final double double6, final double double7) {
        super(world, double2, double3, double4, double5, double6, double7);
        this.particleRed = 1.0f;
        this.particleGreen = 1.0f;
        this.particleBlue = 1.0f;
        this.particleTextureIndex = 32;
        this.setSize(0.02f, 0.02f);
        this.particleScale *= this.rand.nextDouble() * 0.6f + 0.2f;
        this.motionX1 = double5 * 0.2f + (double)(Math.random() * 2.0 - 1.0) * 0.02f;
        this.motionY1 = double6 * 0.2f + (double)(Math.random() * 2.0 - 1.0) * 0.02f;
        this.motionZ1 = double7 * 0.2f + (double)(Math.random() * 2.0 - 1.0) * 0.02f;
        this.particleMaxAge = (int)(8.0 / (Math.random() * 0.8 + 0.2));
    }
    
    @Override
    public final void onEntityUpdate() {
        this.prevPosX = this.posX;
        this.prevPosY = this.posY;
        this.prevPosZ = this.posZ;
        this.motionY1 += (double)0.002;
        this.moveEntity(this.motionX1, this.motionY1, this.motionZ1);
        this.motionX1 *= 0.85f;
        this.motionY1 *= 0.85f;
        this.motionZ1 *= 0.85f;
        if (this.worldObj.getBlockMaterial((int)this.posX, (int)this.posY, (int)this.posZ) != Material.water) {
            this.setEntityDead();
        }
        if (this.particleMaxAge-- <= 0) {
            this.setEntityDead();
        }
    }
}
