package net.minecraft.client.player;

import net.minecraft.client.particle.EntityFX;
import net.minecraft.game.entity.EntityLiving;
import net.minecraft.client.particle.EntityPickupFX;
import net.minecraft.game.entity.Entity;
import net.minecraft.client.gui.GuiFurnace;
import net.minecraft.game.block.tileentity.TileEntityFurnace;
import net.minecraft.client.gui.GuiCrafting;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.GuiChest;
import net.minecraft.client.inventory.IInventory;
import net.minecraft.game.item.ItemStack;
import net.minecraft.game.entity.player.InventoryPlayer;

import org.lwjgl.input.Keyboard;

import com.nbt.NBTBase;
import com.nbt.NBTTagList;
import com.nbt.NBTTagCompound;
import net.minecraft.client.SessionData;
import net.minecraft.game.level.World;
import net.minecraft.client.Minecraft;
import net.minecraft.game.entity.player.EntityPlayer;

public class EntityPlayerSP extends EntityPlayer {
    public MovementInput movementInput;
    private Minecraft mc;
    
    public EntityPlayerSP(final Minecraft minecraft, final World world, final SessionData sessionData) {
        super(world);
        this.mc = minecraft;
        if (sessionData != null) {
        	//this.skinUrl = "http://www.minecraft.net/skin/" + sessionData.username + ".png";
        	this.skinUrl = "http://mcresources.modification-station.net/skinapi.php?user=" + sessionData.username + ".png";
        }
    }
    
    public final void updatePlayerActionState() {
        this.moveStrafing = this.movementInput.moveStrafe;
        this.moveForward = this.movementInput.moveForward;
        this.isJumping = this.movementInput.jump;
    }
    
    @Override
    public final void onLivingUpdate() {
        this.movementInput.updatePlayerMoveState();
        super.onLivingUpdate();
        if(movementInput.isFlying) {
        	this.motionY = 0;
        	if(movementInput.jump) {
        		this.motionY += 0.42D;
        	}
        	if(Keyboard.isKeyDown(Keyboard.KEY_LSHIFT)) {
        		this.motionY -= 0.42D;
        	}
        }
    }
    
    public void moveFlying(double double1, double double2, double double3) {
    	if(movementInput.isFlying) {
    		double3 = 0.1;
    	}
    	super.moveFlying(double1, double2, double3);
    }
    
    @Override
    protected final void writeEntityToNBT(final NBTTagCompound nbtTagCompound) {
        super.writeEntityToNBT(nbtTagCompound);
        nbtTagCompound.setInteger("Score", this.getScore);
        final String string = "Inventory";
        final InventoryPlayer inventory = this.inventory;
        final NBTTagList j = new NBTTagList();
        final InventoryPlayer inventoryPlayer = inventory;
        for (int i = 0; i < inventoryPlayer.mainInventory.length; ++i) {
            if (inventoryPlayer.mainInventory[i] != null) {
                final NBTTagCompound nbtTagCompound2;
                (nbtTagCompound2 = new NBTTagCompound()).setByte("Slot", (byte)i);
                inventoryPlayer.mainInventory[i].writeToNBT(nbtTagCompound2);
                j.setTag(nbtTagCompound2);
            }
        }
        for (int i = 0; i < inventoryPlayer.armorInventory.length; ++i) {
            if (inventoryPlayer.armorInventory[i] != null) {
                final NBTTagCompound nbtTagCompound3;
                (nbtTagCompound3 = new NBTTagCompound()).setByte("Slot", (byte)(i + 100));
                inventoryPlayer.armorInventory[i].writeToNBT(nbtTagCompound3);
                j.setTag(nbtTagCompound3);
            }
        }
        nbtTagCompound.setTag(string, j);
    }
    
    @Override
    protected final void readEntityFromNBT(final NBTTagCompound nbtTagCompound) {
        super.readEntityFromNBT(nbtTagCompound);
        this.getScore = nbtTagCompound.getInteger("Score");
        final NBTTagList tagList = nbtTagCompound.getTagList("Inventory");
        final InventoryPlayer inventory = this.inventory;
        final NBTTagList list = tagList;
        final InventoryPlayer inventoryPlayer = inventory;
        inventory.mainInventory = new ItemStack[36];
        inventoryPlayer.armorInventory = new ItemStack[4];
        for (int i = 0; i < list.tagCount(); ++i) {
            final NBTTagCompound nbtTagCompound2;
            final int n;
            if ((n = ((nbtTagCompound2 = (NBTTagCompound)list.tagAt(i)).getByte("Slot") & 0xFF)) >= 0 && n < inventoryPlayer.mainInventory.length) {
                inventoryPlayer.mainInventory[n] = new ItemStack(nbtTagCompound2);
            }
            if (n >= 100 && n < inventoryPlayer.armorInventory.length + 100) {
                inventoryPlayer.armorInventory[n - 100] = new ItemStack(nbtTagCompound2);
            }
        }
    }
    
    @Override
    protected final String getEntityString() {
        return "LocalPlayer";
    }
    
    @Override
    public final void displayGUIChest(final IInventory iInventory) {
        this.mc.displayGuiScreen(new GuiChest(this.inventory, iInventory));
    }
    
    @Override
    public final void displayWorkbenchGUI() {
        this.mc.displayGuiScreen(new GuiCrafting(this.inventory));
    }
    
    @Override
    public final void displayGUIFurnace(final TileEntityFurnace furnace) {
        this.mc.displayGuiScreen(new GuiFurnace(this.inventory, furnace));
    }
    
    public final void displayGUIInventory() {
        this.inventory.setInventorySlotContents(this.inventory.currentItem, null);
    }
    
    @Override
    public final void onItemPickup(final Entity entity) {
        this.mc.effectRenderer.addEffect(new EntityPickupFX(this.mc.theWorld, entity, this, -0.5f));
    }
}
