package net.minecraft.client.renderer;

import net.minecraft.game.MathHelper;
import org.lwjgl.opengl.GL11;
import org.lwjgl.BufferUtils;
import java.nio.DoubleBuffer;

public final class ClippingHelperImpl extends ClippingHelper {
    private static ClippingHelperImpl instance;
    private DoubleBuffer projectionMatrixBuffer;
    private DoubleBuffer modelviewMatrixBuffer;
    private DoubleBuffer doubleBuffer16;
    
    public ClippingHelperImpl() {
        this.projectionMatrixBuffer = BufferUtils.createDoubleBuffer(16);
        this.modelviewMatrixBuffer = BufferUtils.createDoubleBuffer(16);
        this.doubleBuffer16 = BufferUtils.createDoubleBuffer(16);
    }
    
    public static ClippingHelper init() {
        final ClippingHelperImpl instance;
        (instance = ClippingHelperImpl.instance).projectionMatrixBuffer.clear();
        instance.modelviewMatrixBuffer.clear();
        instance.doubleBuffer16.clear();
        GL11.glGetDouble(2983, instance.projectionMatrixBuffer);
        GL11.glGetDouble(2982, instance.modelviewMatrixBuffer);
        instance.projectionMatrixBuffer.flip().limit(16);
        instance.projectionMatrixBuffer.get(instance.projectionMatrix);
        instance.modelviewMatrixBuffer.flip().limit(16);
        instance.modelviewMatrixBuffer.get(instance.modelviewMatrix);
        instance.clippingMatrix[0] = instance.modelviewMatrix[0] * instance.projectionMatrix[0] + instance.modelviewMatrix[1] * instance.projectionMatrix[4] + instance.modelviewMatrix[2] * instance.projectionMatrix[8] + instance.modelviewMatrix[3] * instance.projectionMatrix[12];
        instance.clippingMatrix[1] = instance.modelviewMatrix[0] * instance.projectionMatrix[1] + instance.modelviewMatrix[1] * instance.projectionMatrix[5] + instance.modelviewMatrix[2] * instance.projectionMatrix[9] + instance.modelviewMatrix[3] * instance.projectionMatrix[13];
        instance.clippingMatrix[2] = instance.modelviewMatrix[0] * instance.projectionMatrix[2] + instance.modelviewMatrix[1] * instance.projectionMatrix[6] + instance.modelviewMatrix[2] * instance.projectionMatrix[10] + instance.modelviewMatrix[3] * instance.projectionMatrix[14];
        instance.clippingMatrix[3] = instance.modelviewMatrix[0] * instance.projectionMatrix[3] + instance.modelviewMatrix[1] * instance.projectionMatrix[7] + instance.modelviewMatrix[2] * instance.projectionMatrix[11] + instance.modelviewMatrix[3] * instance.projectionMatrix[15];
        instance.clippingMatrix[4] = instance.modelviewMatrix[4] * instance.projectionMatrix[0] + instance.modelviewMatrix[5] * instance.projectionMatrix[4] + instance.modelviewMatrix[6] * instance.projectionMatrix[8] + instance.modelviewMatrix[7] * instance.projectionMatrix[12];
        instance.clippingMatrix[5] = instance.modelviewMatrix[4] * instance.projectionMatrix[1] + instance.modelviewMatrix[5] * instance.projectionMatrix[5] + instance.modelviewMatrix[6] * instance.projectionMatrix[9] + instance.modelviewMatrix[7] * instance.projectionMatrix[13];
        instance.clippingMatrix[6] = instance.modelviewMatrix[4] * instance.projectionMatrix[2] + instance.modelviewMatrix[5] * instance.projectionMatrix[6] + instance.modelviewMatrix[6] * instance.projectionMatrix[10] + instance.modelviewMatrix[7] * instance.projectionMatrix[14];
        instance.clippingMatrix[7] = instance.modelviewMatrix[4] * instance.projectionMatrix[3] + instance.modelviewMatrix[5] * instance.projectionMatrix[7] + instance.modelviewMatrix[6] * instance.projectionMatrix[11] + instance.modelviewMatrix[7] * instance.projectionMatrix[15];
        instance.clippingMatrix[8] = instance.modelviewMatrix[8] * instance.projectionMatrix[0] + instance.modelviewMatrix[9] * instance.projectionMatrix[4] + instance.modelviewMatrix[10] * instance.projectionMatrix[8] + instance.modelviewMatrix[11] * instance.projectionMatrix[12];
        instance.clippingMatrix[9] = instance.modelviewMatrix[8] * instance.projectionMatrix[1] + instance.modelviewMatrix[9] * instance.projectionMatrix[5] + instance.modelviewMatrix[10] * instance.projectionMatrix[9] + instance.modelviewMatrix[11] * instance.projectionMatrix[13];
        instance.clippingMatrix[10] = instance.modelviewMatrix[8] * instance.projectionMatrix[2] + instance.modelviewMatrix[9] * instance.projectionMatrix[6] + instance.modelviewMatrix[10] * instance.projectionMatrix[10] + instance.modelviewMatrix[11] * instance.projectionMatrix[14];
        instance.clippingMatrix[11] = instance.modelviewMatrix[8] * instance.projectionMatrix[3] + instance.modelviewMatrix[9] * instance.projectionMatrix[7] + instance.modelviewMatrix[10] * instance.projectionMatrix[11] + instance.modelviewMatrix[11] * instance.projectionMatrix[15];
        instance.clippingMatrix[12] = instance.modelviewMatrix[12] * instance.projectionMatrix[0] + instance.modelviewMatrix[13] * instance.projectionMatrix[4] + instance.modelviewMatrix[14] * instance.projectionMatrix[8] + instance.modelviewMatrix[15] * instance.projectionMatrix[12];
        instance.clippingMatrix[13] = instance.modelviewMatrix[12] * instance.projectionMatrix[1] + instance.modelviewMatrix[13] * instance.projectionMatrix[5] + instance.modelviewMatrix[14] * instance.projectionMatrix[9] + instance.modelviewMatrix[15] * instance.projectionMatrix[13];
        instance.clippingMatrix[14] = instance.modelviewMatrix[12] * instance.projectionMatrix[2] + instance.modelviewMatrix[13] * instance.projectionMatrix[6] + instance.modelviewMatrix[14] * instance.projectionMatrix[10] + instance.modelviewMatrix[15] * instance.projectionMatrix[14];
        instance.clippingMatrix[15] = instance.modelviewMatrix[12] * instance.projectionMatrix[3] + instance.modelviewMatrix[13] * instance.projectionMatrix[7] + instance.modelviewMatrix[14] * instance.projectionMatrix[11] + instance.modelviewMatrix[15] * instance.projectionMatrix[15];
        instance.frustrum[0][0] = instance.clippingMatrix[3] - instance.clippingMatrix[0];
        instance.frustrum[0][1] = instance.clippingMatrix[7] - instance.clippingMatrix[4];
        instance.frustrum[0][2] = instance.clippingMatrix[11] - instance.clippingMatrix[8];
        instance.frustrum[0][3] = instance.clippingMatrix[15] - instance.clippingMatrix[12];
        normalize(instance.frustrum, 0);
        instance.frustrum[1][0] = instance.clippingMatrix[3] + instance.clippingMatrix[0];
        instance.frustrum[1][1] = instance.clippingMatrix[7] + instance.clippingMatrix[4];
        instance.frustrum[1][2] = instance.clippingMatrix[11] + instance.clippingMatrix[8];
        instance.frustrum[1][3] = instance.clippingMatrix[15] + instance.clippingMatrix[12];
        normalize(instance.frustrum, 1);
        instance.frustrum[2][0] = instance.clippingMatrix[3] + instance.clippingMatrix[1];
        instance.frustrum[2][1] = instance.clippingMatrix[7] + instance.clippingMatrix[5];
        instance.frustrum[2][2] = instance.clippingMatrix[11] + instance.clippingMatrix[9];
        instance.frustrum[2][3] = instance.clippingMatrix[15] + instance.clippingMatrix[13];
        normalize(instance.frustrum, 2);
        instance.frustrum[3][0] = instance.clippingMatrix[3] - instance.clippingMatrix[1];
        instance.frustrum[3][1] = instance.clippingMatrix[7] - instance.clippingMatrix[5];
        instance.frustrum[3][2] = instance.clippingMatrix[11] - instance.clippingMatrix[9];
        instance.frustrum[3][3] = instance.clippingMatrix[15] - instance.clippingMatrix[13];
        normalize(instance.frustrum, 3);
        instance.frustrum[4][0] = instance.clippingMatrix[3] - instance.clippingMatrix[2];
        instance.frustrum[4][1] = instance.clippingMatrix[7] - instance.clippingMatrix[6];
        instance.frustrum[4][2] = instance.clippingMatrix[11] - instance.clippingMatrix[10];
        instance.frustrum[4][3] = instance.clippingMatrix[15] - instance.clippingMatrix[14];
        normalize(instance.frustrum, 4);
        instance.frustrum[5][0] = instance.clippingMatrix[3] + instance.clippingMatrix[2];
        instance.frustrum[5][1] = instance.clippingMatrix[7] + instance.clippingMatrix[6];
        instance.frustrum[5][2] = instance.clippingMatrix[11] + instance.clippingMatrix[10];
        instance.frustrum[5][3] = instance.clippingMatrix[15] + instance.clippingMatrix[14];
        normalize(instance.frustrum, 5);
        return ClippingHelperImpl.instance;
    }
    
    private static void normalize(final double[][] arr, final int integer) {
        final double sqrt_double = MathHelper.sqrt_double(arr[integer][0] * arr[integer][0] + arr[integer][1] * arr[integer][1] + arr[integer][2] * arr[integer][2]);
        final double[] array = arr[integer];
        final int n = 0;
        array[n] /= sqrt_double;
        final double[] array2 = arr[integer];
        final int n2 = 1;
        array2[n2] /= sqrt_double;
        final double[] array3 = arr[integer];
        final int n3 = 2;
        array3[n3] /= sqrt_double;
        final double[] array4 = arr[integer];
        final int n4 = 3;
        array4[n4] /= sqrt_double;
    }
    
    static {
        ClippingHelperImpl.instance = new ClippingHelperImpl();
    }
}
