package net.minecraft.client.renderer;

import net.minecraft.client.physics.AxisAlignedBB;

public final class Frustrum implements ICamera {
    private ClippingHelper clippingHelper;
    private double tranX, tranY, tranZ;
    
    public Frustrum() {
        this.clippingHelper = ClippingHelperImpl.init();
    }
    
    public final boolean isBoundingBoxInFrustrum(AxisAlignedBB aabb) {
        final ClippingHelper clippingHelper = this.clippingHelper;
        aabb = aabb.copy().addCoord(tranZ, tranY, tranX);
        double minX = aabb.minX;
        double minY = aabb.minY;
        double minZ = aabb.minZ;
        double maxX = aabb.maxX;
        double maxY = aabb.maxY;
        double maxZ = aabb.maxZ;
        
        final double n = maxY;
        final double n2 = maxX;
        final double n3 = minZ;
        final double n4 = minY;
        final double n5 = minX;
        final ClippingHelper clippingHelper2 = clippingHelper;
        for (int i = 0; i < 6; ++i) {
            if (clippingHelper2.frustrum[i][0] * n5 + clippingHelper2.frustrum[i][1] * n4 + clippingHelper2.frustrum[i][2] * n3 + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n2 + clippingHelper2.frustrum[i][1] * n4 + clippingHelper2.frustrum[i][2] * n3 + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n5 + clippingHelper2.frustrum[i][1] * n + clippingHelper2.frustrum[i][2] * n3 + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n2 + clippingHelper2.frustrum[i][1] * n + clippingHelper2.frustrum[i][2] * n3 + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n5 + clippingHelper2.frustrum[i][1] * n4 + clippingHelper2.frustrum[i][2] * maxZ + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n2 + clippingHelper2.frustrum[i][1] * n4 + clippingHelper2.frustrum[i][2] * maxZ + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n5 + clippingHelper2.frustrum[i][1] * n + clippingHelper2.frustrum[i][2] * maxZ + clippingHelper2.frustrum[i][3] <= 0.0f && clippingHelper2.frustrum[i][0] * n2 + clippingHelper2.frustrum[i][1] * n + clippingHelper2.frustrum[i][2] * maxZ + clippingHelper2.frustrum[i][3] <= 0.0f) {
                return false;
            }
        }
        return true;
    }
    
    public void setTranslation(double x, double y, double z) {
    	this.tranX = x;
    	this.tranY = y;
    	this.tranZ = z;
    }
}
