package net.minecraft.client.renderer;

import org.lwjgl.BufferUtils;
import org.lwjgl.opengl.GL11;
import java.nio.DoubleBuffer;
import java.nio.FloatBuffer;

public final class RenderHelper {
    private static FloatBuffer colorBuffer;
    
    public static void disableStandardItemLighting() {
        GL11.glDisable(2896);
        GL11.glDisable(16384);
        GL11.glDisable(16385);
        GL11.glDisable(2903);
    }
    
    public static void enableStandardItemLighting() {
        GL11.glEnable(2896);
        GL11.glEnable(16384);
        GL11.glEnable(16385);
        GL11.glEnable(2903);
        GL11.glColorMaterial(1032, 5634);
        final Vec3D vec3D = new Vec3D(0.3f, 1.0f, -0.7f);
        GL11.glLight(16384, 4611, setColorBuffer(vec3D.xCoord, vec3D.yCoord, vec3D.zCoord, 0.0f));
        GL11.glLight(16384, 4609, setColorBuffer(0.5f, 0.5f, 0.5f, 1.0f));
        GL11.glLight(16384, 4608, setColorBuffer(0.0f, 0.0f, 0.0f, 1.0f));
        GL11.glLight(16384, 4610, setColorBuffer(0.0f, 0.0f, 0.0f, 1.0f));
        final Vec3D vec3D2 = new Vec3D(-0.7f, 1.0f, 0.2f);
        GL11.glLight(16385, 4611, setColorBuffer(vec3D2.xCoord, vec3D2.yCoord, vec3D2.zCoord, 0.0f));
        GL11.glLight(16385, 4609, setColorBuffer(0.5f, 0.5f, 0.5f, 1.0f));
        GL11.glLight(16385, 4608, setColorBuffer(0.0f, 0.0f, 0.0f, 1.0f));
        GL11.glLight(16385, 4610, setColorBuffer(0.0f, 0.0f, 0.0f, 1.0f));
        GL11.glShadeModel(7425);
        GL11.glLightModel(2899, setColorBuffer(0.5f, 0.5f, 0.5f, 1.0f));
    }
    
    private static FloatBuffer setColorBuffer(final double double1, final double double2, final double double3, final double double4) {
        RenderHelper.colorBuffer.clear();
        RenderHelper.colorBuffer.put((float)double1).put((float)double2).put((float)double3).put((float)double4);
        RenderHelper.colorBuffer.flip();
        return RenderHelper.colorBuffer;
    }
    
    static {
        RenderHelper.colorBuffer = BufferUtils.createFloatBuffer(16);
    }
}
