package net.minecraft.client.renderer.entity;

import net.minecraft.game.MathHelper;
import net.minecraft.game.entity.other.EntityItem;
import net.minecraft.game.entity.Entity;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.renderer.Tessellator;
import org.lwjgl.opengl.GL11;
import net.minecraft.game.block.Block;
import net.minecraft.game.item.ItemStack;
import net.minecraft.client.renderer.RenderEngine;
import java.util.Random;
import net.minecraft.client.renderer.RenderBlocks;

public final class RenderItem extends Render {
    private RenderBlocks renderBlocks;
    private Random random;
    
    public RenderItem() {
        this.renderBlocks = new RenderBlocks();
        this.random = new Random();
        this.shadowSize = 0.15f;
        this.shadowOpaque = 0.75f;
    }
    
    public final void renderItemIntoGUI(final RenderEngine renderEngineClass, final ItemStack itemStackClass, int integer3, int integer4) {
        if (itemStackClass == null) {
            return;
        }
        if (itemStackClass.itemID < 256 && Block.blocksList[itemStackClass.itemID].getRenderType() == 0) {
            final int itemID = itemStackClass.itemID;
            RenderEngine.bindTexture(renderEngineClass.getTexture("/terrain.png"));
            final Block block = Block.blocksList[itemID];
            GL11.glPushMatrix();
            GL11.glTranslated((double)(integer3 - 2), (double)(integer4 + 3), 0.0f);
            GL11.glScaled(10.0f, 10.0f, 10.0f);
            GL11.glTranslated(1.0f, 0.5f, 8.0f);
            GL11.glRotated(210.0f, 1.0f, 0.0f, 0.0f);
            GL11.glRotated(45.0f, 0.0f, 1.0f, 0.0f);
            GL11.glColor4d(1.0f, 1.0f, 1.0f, 1.0f);
            this.renderBlocks.renderBlockOnInventory(block);
            GL11.glPopMatrix();
            return;
        }
        if (itemStackClass.getItem().getIconFromDamage() >= 0) {
            GL11.glDisable(2896);
            if (itemStackClass.itemID < 256) {
                RenderEngine.bindTexture(renderEngineClass.getTexture("/terrain.png"));
            }
            else {
                RenderEngine.bindTexture(renderEngineClass.getTexture("/gui/items.png"));
            }
            final int n = integer3;
            final int n2 = integer4;
            final int n3 = itemStackClass.getItem().getIconFromDamage() % 16 << 4;
            final int n4 = itemStackClass.getItem().getIconFromDamage() / 16 << 4;
            final int n5 = 16;
            int n6 = 16;
            n6 = n5;
            integer4 = n4;
            integer3 = n3;
            final int itemID = n2;
            n6 = n;
            final Tessellator instance;
            (instance = Tessellator.instance).startDrawingQuads();
            instance.addVertexWithUV((double)n6, (double)(itemID + 16), 0.0f, integer3 * 0.00390625f, (integer4 + 16) * 0.00390625f);
            instance.addVertexWithUV((double)(n6 + 16), (double)(itemID + 16), 0.0f, (integer3 + 16) * 0.00390625f, (integer4 + 16) * 0.00390625f);
            instance.addVertexWithUV((double)(n6 + 16), (double)itemID, 0.0f, (integer3 + 16) * 0.00390625f, integer4 * 0.00390625f);
            instance.addVertexWithUV((double)n6, (double)itemID, 0.0f, integer3 * 0.00390625f, integer4 * 0.00390625f);
            instance.draw();
            GL11.glEnable(2896);
        }
    }
    
    public final void renderItemOverlayIntoGUI(final FontRenderer j, final ItemStack k, final int integer3, final int integer4) {
        if (k == null) {
            return;
        }
        if (k.stackSize > 1) {
            final String string = new StringBuilder().append("").append(k.stackSize).toString();
            GL11.glDisable(2896);
            GL11.glDisable(2929);
            j.drawStringWithShadow(string, integer3 + 19 - 2 - j.getStringWidth(string), integer4 + 6 + 3, 16777215);
            GL11.glEnable(2896);
            GL11.glEnable(2929);
        }
        if (k.itemDamage > 0) {
            final int integer5 = 13 - k.itemDamage * 13 / k.isItemStackDamageable();
            int integer6 = 255 - k.itemDamage * 255 / k.isItemStackDamageable();
            GL11.glDisable(2896);
            GL11.glDisable(2929);
            GL11.glDisable(3553);
            final Tessellator instance = Tessellator.instance;
            final int integer7 = 255 - integer6 << 16 | integer6 << 8;
            integer6 = ((255 - integer6) / 4 << 16 | 0x3F00);
            renderQuad(instance, integer3 + 2, integer4 + 13, 13, 2, 0);
            renderQuad(instance, integer3 + 2, integer4 + 13, 12, 1, integer6);
            renderQuad(instance, integer3 + 2, integer4 + 13, integer5, 1, integer7);
            GL11.glEnable(3553);
            GL11.glEnable(2896);
            GL11.glEnable(2929);
            GL11.glColor4d(1.0f, 1.0f, 1.0f, 1.0f);
        }
    }
    
    private static void renderQuad(final Tessellator d, final int integer2, final int integer3, final int integer4, final int integer5, final int integer6) {
        d.startDrawingQuads();
        d.setColorOpaque_I(integer6);
        d.addVertex((double)integer2, (double)integer3, 0.0f);
        d.addVertex((double)integer2, (double)(integer3 + integer5), 0.0f);
        d.addVertex((double)(integer2 + integer4), (double)(integer3 + integer5), 0.0f);
        d.addVertex((double)(integer2 + integer4), (double)integer3, 0.0f);
        d.draw();
    }
    
    public final void doRenderItem(EntityItem entity, double f, double f2, double f3, double f4, double f5) {
        EntityItem item = (EntityItem) entity;
        this.random.setSeed(187);
        ItemStack itemStack = item.item;
        GL11.glPushMatrix();
        double a = 0.1f + (MathHelper.sin(((((double) item.age) + f5) / 10.0f) + item.hoverStart) * 0.1f);
        double f6 = 57.295776f * (((((double) item.age) + f5) / 20.0f) + item.hoverStart);
        int i = 1;
        if (item.item.stackSize > 1) {
            i = 2;
        }
        if (item.item.stackSize > 5) {
            i = 3;
        }
        int i2 = item.item.stackSize > 20 ? 4 : i;
        GL11.glTranslated(f, f2 + a, f3);
        GL11.glEnable(2977);
        if (itemStack.itemID >= 256 || Block.blocksList[itemStack.itemID].getRenderType() != 0) {
            GL11.glScaled(0.5f, 0.5f, 0.5f);
            int b = itemStack.getItem().getIconFromDamage();
            if (itemStack.itemID < 256) {
                loadTexture("/terrain.png");
            } else {
                loadTexture("/gui/items.png");
            }
            Tessellator dVar = Tessellator.instance;
            double f7 = ((double) ((b % 16) << 4)) / 256.0f;
            double f8 = ((double) (((b % 16) << 4) + 16)) / 256.0f;
            double f9 = ((double) ((b / 16) << 4)) / 256.0f;
            double f10 = ((double) (((b / 16) << 4) + 16)) / 256.0f;
            for (int i3 = 0; i3 < i2; i3++) {
                GL11.glPushMatrix();
                if (i3 > 0) {
                    GL11.glTranslated(((this.random.nextDouble() * 2.0f) - 1.0f) * 0.3f, ((this.random.nextDouble() * 2.0f) - 1.0f) * 0.3f, ((this.random.nextDouble() * 2.0f) - 1.0f) * 0.3f);
                }
                GL11.glRotated(180.0f - this.renderManager.playerViewY, 0.0f, 1.0f, 0.0f);
                dVar.startDrawingQuads();
                Tessellator.setNormal(0.0f, 1.0f, 0.0f);
                dVar.addVertexWithUV(-0.5f, -0.25f, 0.0f, f7, f10);
                dVar.addVertexWithUV(0.5f, -0.25f, 0.0f, f8, f10);
                dVar.addVertexWithUV(0.5f, 0.75f, 0.0f, f8, f9);
                dVar.addVertexWithUV(-0.5f, 0.75f, 0.0f, f7, f9);
                dVar.draw();
                GL11.glPopMatrix();
            }
        } else {
            GL11.glRotated(f6, 0.0f, 1.0f, 0.0f);
            loadTexture("/terrain.png");
            double f11 = 0.25f;
            if (!Block.blocksList[itemStack.itemID].renderAsNormalBlock() && itemStack.itemID != Block.stairSingle.blockID) {
                f11 = 0.5f;
            }
            GL11.glScaled(f11, f11, f11);
            for (int i4 = 0; i4 < i2; i4++) {
                GL11.glPushMatrix();
                if (i4 > 0) {
                    GL11.glTranslated((((this.random.nextDouble() * 2.0f) - 1.0f) * 0.2f) / f11, (((this.random.nextDouble() * 2.0f) - 1.0f) * 0.2f) / f11, (((this.random.nextDouble() * 2.0f) - 1.0f) * 0.2f) / f11);
                }
                this.renderBlocks.renderBlockOnInventory(Block.blocksList[itemStack.itemID]);
                GL11.glPopMatrix();
            }
        }
        GL11.glDisable(2977);
        GL11.glPopMatrix();
    }

	public void doRender(Entity p0, double p1, double p2, double p3, double p4, double p5)
	{
		this.doRenderItem((EntityItem)p0, p1, p2, p3, p4, p5);
	}
}
