package net.minecraft.game.block;

import net.minecraft.game.level.World;

public class BlockLeavesBase extends Block {
    private boolean graphicsLevel;
    
    protected BlockLeavesBase(final int blockID, final int textureSlot, final Material material, final boolean boolean4) {
        super(blockID, textureSlot, material);
        this.graphicsLevel = true;
    }
    
    @Override
    public final boolean isOpaqueCube() {
        return false;
    }
    
    @Override
    public final boolean shouldSideBeRendered(final World world, final int xCoord, final int yCoord, final int zCoord, final int integer5) {
        final int blockId = world.getBlockId(xCoord, yCoord, zCoord);
        return (this.graphicsLevel || blockId != this.blockID) && super.shouldSideBeRendered(world, xCoord, yCoord, zCoord, integer5);
    }
}
