package net.minecraft.game.block;

import java.util.Random;
import net.minecraft.game.level.World;

public final class BlockSapling extends BlockFlower {
    protected BlockSapling(final int blockID, final int textureSlot) {
        super(6, 15);
        this.setBlockBounds(0.099999994f, 0.0f, 0.099999994f, 0.9f, 0.8f, 0.9f);
    }
    
    @Override
    public final void updateTick(final World world, final int xCoord, final int yCoord, final int zCoord, final Random random) {
        super.updateTick(world, xCoord, yCoord, zCoord, random);
        if (world.getBlockLightValue(xCoord, yCoord + 1, zCoord) >= 9 && random.nextInt(5) == 0) {
            final byte blockMetadata;
            if ((blockMetadata = world.getBlockMetadata(xCoord, yCoord, zCoord)) < 15) {
                world.setBlockMetadataWithNotify(xCoord, yCoord, zCoord, blockMetadata + 1);
                return;
            }
            world.setTileNoUpdate(xCoord, yCoord, zCoord, 0);
            if (!world.growTrees(xCoord, yCoord, zCoord)) {
                world.setTileNoUpdate(xCoord, yCoord, zCoord, this.blockID);
            }
        }
    }
}
