package net.minecraft.game.block;

import java.util.Random;
import net.minecraft.game.level.World;

public final class BlockStep extends Block {
    private boolean blockType;
    
    public BlockStep(final int blockID, final boolean boolean2) {
        super(blockID, 6, Material.rock);
        if (!(this.blockType = boolean2)) {
            this.setBlockBounds(0.0f, 0.0f, 0.0f, 1.0f, 0.5f, 1.0f);
        }
        this.setLightOpacity(255);
    }
    
    @Override
    public final int getBlockTextureFromSide(final int blockSide) {
        if (blockSide <= 1) {
            return 6;
        }
        return 5;
    }
    
    @Override
    public final boolean isOpaqueCube() {
        return this.blockType;
    }
    
    @Override
    public final void onNeighborBlockChange(final World world, final int xCoord, final int yCoord, final int zCoord, final int blockID) {
        if (this != Block.stairSingle) {
            return;
        }
    }
    
    @Override
    public final void onBlockAdded(final World world, final int xCoord, final int yCoord, final int zCoord) {
        if (this != Block.stairSingle) {
            super.onBlockAdded(world, xCoord, yCoord, zCoord);
        }
        if (world.getBlockId(xCoord, yCoord - 1, zCoord) == BlockStep.stairSingle.blockID) {
            world.setBlockWithNotify(xCoord, yCoord, zCoord, 0);
            world.setBlockWithNotify(xCoord, yCoord - 1, zCoord, Block.stairDouble.blockID);
        }
    }
    
    @Override
    public final int idDropped(final int integer, final Random random) {
        return Block.stairSingle.blockID;
    }
    
    @Override
    public final boolean renderAsNormalBlock() {
        return this.blockType;
    }
    
    @Override
    public final boolean shouldSideBeRendered(final World world, final int xCoord, final int yCoord, final int zCoord, final int integer5) {
        return integer5 == 1 || (super.shouldSideBeRendered(world, xCoord, yCoord, zCoord, integer5) && (integer5 == 0 || world.getBlockId(xCoord, yCoord, zCoord) != this.blockID));
    }
}
