package net.minecraft.game.block;

import net.minecraft.game.entity.Entity;
import net.minecraft.game.entity.other.EntityTNT;
import net.minecraft.game.level.World;
import java.util.Random;

public final class BlockTNT extends Block {
    public BlockTNT(final int blockID, final int textureSlot) {
        super(46, 8, Material.tnt);
    }
    
    @Override
    public final int getBlockTextureFromSide(final int blockSide) {
        if (blockSide == 0) {
            return this.blockIndexInTexture + 2;
        }
        if (blockSide == 1) {
            return this.blockIndexInTexture + 1;
        }
        return this.blockIndexInTexture;
    }
    
    @Override
    public final int quantityDropped(final Random random) {
        return 0;
    }
    
    @Override
    public final void onBlockDestroyedByExplosion(final World world, final int xCoord, final int yCoord, final int zCoord) {
        final EntityTNT entity;
        final EntityTNT entityTNT = entity = new EntityTNT(world, xCoord + 0.5f, yCoord + 0.5f, zCoord + 0.5f);
        entityTNT.fuse = world.random.nextInt(entity.fuse / 4) + entity.fuse / 8;
        world.entityJoinedWorld(entity);
    }
    
    @Override
    public final void onBlockDestroyedByPlayer(final World world, final int xCoord, final int yCoord, final int zCoord, final int integer5) {
        final EntityTNT entityTNT = new EntityTNT(world, xCoord + 0.5f, yCoord + 0.5f, zCoord + 0.5f);
        world.entityJoinedWorld(entityTNT);
        world.playSoundAtEntity((Entity)entityTNT, "random.fuse", 1.0f, 1.0f);
    }
}
