package net.minecraft.game.entity;

import net.minecraft.client.renderer.Vec3D;

public final class PathEntity {
    private final PathPoint[] points;
    private int pathIndex;
    
    public PathEntity(final PathPoint[] points) {
        this.points = points;
    }
    
    public final void incrementPathIndex() {
        ++this.pathIndex;
    }
    
    public final boolean isFinished() {
        return this.pathIndex >= this.points.length;
    }
    
    public final Vec3D getPosition(final Entity entity) {
        return new Vec3D(this.points[this.pathIndex].xCoord + (int)(entity.width + 1.0f) * 0.5f, (double)this.points[this.pathIndex].yCoord, this.points[this.pathIndex].zCoord + (int)(entity.width + 1.0f) * 0.5f);
    }
}
