package net.minecraft.game.item;

import net.minecraft.game.entity.EntityLiving;
import net.minecraft.game.entity.other.EntityArrow;
import net.minecraft.game.entity.Entity;
import net.minecraft.game.entity.player.EntityPlayer;
import net.minecraft.game.level.World;

public final class ItemBow extends Item {
    public ItemBow(final int itemID) {
        super(5);
        this.maxStackSize = 1;
    }
    
    @Override
    public final ItemStack onItemRightClick(final ItemStack itemStack, final World world, final EntityPlayer entityPlayer) {
        if (entityPlayer.inventory.consumeInventoryItem(Item.arrow.shiftedIndex)) {
            world.playSoundAtEntity((Entity)entityPlayer, "random.bow", 1.0f, 1.0f / (ItemBow.itemRand.nextDouble() * 0.4f + 0.8f));
            world.entityJoinedWorld(new EntityArrow(world, entityPlayer));
        }
        return itemStack;
    }
}
