package net.minecraft.game.item;

import net.minecraft.game.block.Material;
import net.minecraft.game.block.Block;

public final class ItemPickaxe extends ItemTool {
    private static Block[] blocksEffectiveAgainst;
    private int getHarvestLevel;
    
    public ItemPickaxe(final int itemID, final int harvestLevel) {
        super(itemID, 2, harvestLevel, ItemPickaxe.blocksEffectiveAgainst);
        this.getHarvestLevel = harvestLevel;
    }
    
    @Override
    public final boolean canHarvestBlock(final Block block) {
        if (block == Block.obsidian) {
            return this.getHarvestLevel == 3;
        }
        if (block == Block.blockDiamond || block == Block.oreDiamond) {
            return this.getHarvestLevel >= 2;
        }
        if (block == Block.blockGold || block == Block.oreGold) {
            return this.getHarvestLevel >= 2;
        }
        if (block == Block.blockSteel || block == Block.oreIron) {
            return this.getHarvestLevel > 0;
        }
        return block.blockMaterial == Material.rock || block.blockMaterial == Material.iron;
    }
    
    static {
        ItemPickaxe.blocksEffectiveAgainst = new Block[] { Block.cobblestone, Block.stairDouble, Block.stairSingle, Block.stone, Block.cobblestoneMossy, Block.oreIron, Block.blockSteel, Block.oreCoal, Block.blockGold, Block.oreGold, Block.oreDiamond, Block.blockDiamond };
    }
}
