package net.minecraft.game.item;

import net.minecraft.game.block.Block;

public class ItemTool extends Item {
    private Block[] blocksEffectiveAgainst;
    private double efficiencyOnProperMaterial;
    private int damageVsEntity;
    
    public ItemTool(final int itemID, final int baseDamage, final int damage, final Block[] blocksEffected) {
        super(itemID);
        this.efficiencyOnProperMaterial = 4.0f;
        this.blocksEffectiveAgainst = blocksEffected;
        this.maxStackSize = 1;
        this.maxDamage = 32 << damage;
        this.efficiencyOnProperMaterial = (double)(damage + 1 << 1);
        this.damageVsEntity = baseDamage + damage;
    }
    
    @Override
    public final double getStrVsBlock(final Block block) {
        for (int i = 0; i < this.blocksEffectiveAgainst.length; ++i) {
            if (this.blocksEffectiveAgainst[i] == block) {
                return this.efficiencyOnProperMaterial;
            }
        }
        return 1.0f;
    }
    
    @Override
    public final void hitEntity(final ItemStack itemStack) {
        itemStack.damageItem(2);
    }
    
    @Override
    public final void onBlockDestroyed(final ItemStack itemStack) {
        itemStack.damageItem(1);
    }
    
    @Override
    public final int getDamageVsEntity() {
        return this.damageVsEntity;
    }
}
