package net.minecraft.game.level;

import net.minecraft.game.block.Block;
import java.util.ArrayList;
import java.util.List;

public final class WorldClient {
    private int worldClientInt1;
    private List worldClientList1;
    private World worldObj;
    private int worldWidth;
    private int worldLength;
    private int worldHeight;
    private byte[] worldClientByteArray1;
    private byte[] blocks;
    private int[] worldClientIntArray1;
    private List worldClientList2;
    private List worldClientList3;
    private List worldClientList4;
    private List worldClientList5;
    private int[] worldClientIntArray2;
    private byte[] worldClientByteArray2;
    private WorldBlockPositionType worldBlockPositionType;
    private int worldClientInt2;
    private int dayNightInt;
    
    public WorldClient(final World world) {
        this.worldClientInt1 = 0;
        this.worldClientList1 = (List)new ArrayList();
        this.worldClientList2 = (List)new ArrayList();
        this.worldClientList3 = (List)new ArrayList();
        this.worldClientList4 = (List)new ArrayList();
        this.worldClientList5 = (List)new ArrayList();
        this.worldClientIntArray2 = this.worldClientMethod1();
        this.worldBlockPositionType = null;
        this.worldClientInt2 = 0;
        this.worldObj = world;
        this.worldWidth = world.width;
        this.worldLength = world.length;
        this.worldHeight = world.height;
        //this.worldClientByteArray2 = new byte[world.blocks.length / 8];
        //this.worldClientByteArray1 = world.blocks;
        this.blocks = world.dataByteArray;
        this.worldClientIntArray1 = world.worldIntArray1;
    }
    
    private int[] worldClientMethod1() {
        if (this.worldClientList5.size() > 0) {
            return (int[])this.worldClientList5.remove(this.worldClientList5.size() - 1);
        }
        return new int[32768];
    }
    
    public final void updateSkylight(final int integer1, final int integer2, final int integer3, final int integer4) {
        //this.worldClientList4.add(new WorldBlockPositionType(this, integer1, integer2, 0, integer3, integer4, 1));
    }
    
    public final void updateDaylightCycle(int integer) {
        if (integer > 15) {
            integer = 15;
        }
        if (integer < 0) {
            integer = 0;
        }
        this.dayNightInt = integer - this.worldObj.skylightSubtracted;
        if (this.dayNightInt == 0) {
            return;
        }
        this.worldClientInt2 = this.worldObj.skylightSubtracted;
        this.worldObj.skylightSubtracted = integer;
        while (this.worldBlockPositionType != null) {
            this.worldClientMethod2(64);
        }
        this.worldBlockPositionType = new WorldBlockPositionType(this, 0, 0, 0, this.worldObj.width, this.worldObj.height, this.worldObj.length);
    }
    
    private void worldClientMethod2(int integer) {
        int i = this.worldBlockPositionType.posX;
        final int acceptCountdown = this.worldBlockPositionType.acceptCountdown;
        final int posZ = this.worldBlockPositionType.posZ;
        final int metadata = this.worldBlockPositionType.metadata;
        for (i = i; i < acceptCountdown; ++i) {
            if (integer-- <= 0 && i != acceptCountdown - 1) {
                this.worldBlockPositionType.posX = i;
                return;
            }
            for (int j = posZ; j < metadata; ++j) {
                int k;
                for (k = this.worldClientIntArray1[i + j * this.worldWidth] - 1; k > 0 && Block.lightOpacity[this.worldClientByteArray1[(k * this.worldLength + j) * this.worldWidth + i]] < 100; --k) {}
                for (++k; k < this.worldHeight; ++k) {
                    final int n = (k * this.worldLength + j) * this.worldWidth + i;
                    final int n2;
                    if (Block.lightValue[this.worldClientByteArray1[n]] == 0 && (n2 = (this.blocks[n] & 0xF)) <= this.worldClientInt2) {
                        if (this.dayNightInt < 0 && n2 > 0) {
                            final byte[] blocks = this.blocks;
                            final int n3 = n;
                            --blocks[n3];
                        }
                        else if (this.dayNightInt > 0 && n2 < 15) {
                            final byte[] blocks2 = this.blocks;
                            final int n4 = n;
                            ++blocks2[n4];
                        }
                    }
                }
            }
        }
        for (int j = 0; j < this.worldWidth; j += 32) {
            for (int k = 0; k < this.worldLength; k += 32) {
                this.worldClientList3.add(new WorldBlockPositionType(this, j, 0, k, j + 32, this.worldHeight, k + 32));
                this.worldClientList2.add(new WorldBlockPositionType(this, j, 0, k, j + 32, this.worldHeight, k + 32));
            }
        }
        for (int j = 0; j < this.worldObj.worldAccesses.size(); ++j) {
            ((IWorldAccess)this.worldObj.worldAccesses.get(j)).updateAllRenderers();
        }
        this.worldBlockPositionType = null;
    }
    
    public final void updateBlockLight(final int integer1, final int integer2, final int integer3, final int integer4, final int integer5, final int integer6) {
        //this.worldClientList3.add(new WorldBlockPositionType(this, integer1, integer2, integer3, integer4, integer5, integer6));
    }
    
    private void lightingSomething(final int integer1, int integer2, final int integer3, final int integer4, final int integer5, final int integer6) {
        int i;
        int j;
        int n;
        byte[] worldClientByteArray2;
        int n2;
        int[] worldClientIntArray2;
        int worldClientInt1;
        for (integer2 = integer2; integer2 < integer5; ++integer2) {
            for (i = integer3; i < integer6; ++i) {
                for (j = integer1; j < integer4; ++j) {
                    n = j + integer2 * this.worldWidth + i * this.worldWidth * this.worldHeight;
                    if ((this.worldClientByteArray2[n >> 3] & 1 << (n & 0x7)) == 0x0) {
                        worldClientByteArray2 = this.worldClientByteArray2;
                        n2 = n >> 3;
                        worldClientByteArray2[n2] |= (byte)(1 << (n & 0x7));
                        this.worldClientIntArray2[this.worldClientInt1++] = n;
                        if ((this.worldClientByteArray2[n >> 3] & 1 << (n & 0x7)) == 0x0) {
                            System.out.println("OMG ERROR!");
                        }
                        if (this.worldClientInt1 > this.worldClientIntArray2.length - 32) {
                            worldClientIntArray2 = this.worldClientIntArray2;
                            worldClientInt1 = this.worldClientInt1 - 1;
                            this.worldClientInt1 = worldClientInt1;
                            n = worldClientIntArray2[worldClientInt1];
                            this.worldClientIntArray2[this.worldClientIntArray2.length - 1] = this.worldClientInt1;
                            this.worldClientList1.add(this.worldClientIntArray2);
                            this.worldClientIntArray2 = this.worldClientMethod1();
                            this.worldClientInt1 = 1;
                            this.worldClientIntArray2[0] = n;
                        }
                    }
                }
            }
        }
    }
    
    public final void tick() {
        if (this.worldClientList5.size() > 0) {
            this.worldClientList5.remove(this.worldClientList5.size() - 1);
        }
        int n = 5;
        while (this.worldClientList2.size() > 0 && n-- > 0) {
            final WorldBlockPositionType worldBlockPositionType = (WorldBlockPositionType)this.worldClientList2.remove(0);
            for (int i = 0; i < this.worldObj.worldAccesses.size(); ++i) {
                ((IWorldAccess)this.worldObj.worldAccesses.get(i)).markBlockRangeNeedsUpdate(worldBlockPositionType.posX, worldBlockPositionType.posY, worldBlockPositionType.posZ, worldBlockPositionType.acceptCountdown, worldBlockPositionType.blockID, worldBlockPositionType.metadata);
            }
        }
        if (this.worldBlockPositionType != null) {
            this.worldClientMethod2(8);
            return;
        }
        for (int j = 0; j < 16; ++j) {
            if (this.worldClientList3.size() > 0) {
                final WorldBlockPositionType worldBlockPositionType2 = (WorldBlockPositionType)this.worldClientList3.remove(0);
                this.lightingSomething(worldBlockPositionType2.posX, worldBlockPositionType2.posY, worldBlockPositionType2.posZ, worldBlockPositionType2.acceptCountdown, worldBlockPositionType2.blockID, worldBlockPositionType2.metadata);
            }
            if (this.worldClientList4.size() > 0) {
                final WorldBlockPositionType worldBlockPositionType3 = (WorldBlockPositionType)this.worldClientList4.remove(0);
                final int posX = worldBlockPositionType3.posX;
                final int posY = worldBlockPositionType3.posY;
                final int acceptCountdown = worldBlockPositionType3.acceptCountdown;
                final int blockID = worldBlockPositionType3.blockID;
                final int acceptCountdown2 = acceptCountdown;
                final int posX2 = posY;
                int k;
                for (int skylightSubtracted = k = posX; k < skylightSubtracted + acceptCountdown2; ++k) {
                    for (int l = posX2; l < posX2 + blockID; ++l) {
                        final int metadata = this.worldClientIntArray1[k + l * this.worldWidth];
                        int n2;
                        for (n2 = this.worldHeight - 1; n2 > 0 && Block.lightOpacity[this.worldClientByteArray1[(n2 * this.worldLength + l) * this.worldWidth + k]] == 0; --n2) {}
                        this.worldClientIntArray1[k + l * this.worldWidth] = n2 + 1;
                        if (metadata != n2) {
                            final int integer2 = (metadata < n2) ? metadata : n2;
                            final int integer3 = (metadata > n2) ? metadata : n2;
                            this.lightingSomething(k, integer2, l, k + 1, integer3, l + 1);
                        }
                    }
                }
            }
            final int skylightSubtracted = this.worldObj.skylightSubtracted;
            int posX2 = -999;
            int acceptCountdown2 = -999;
            int blockID = -999;
            int k = -999;
            int l = -999;
            int metadata = -999;
            int n2 = 1024;
            int integer2 = 0;
            while (n2-- > 0 && (this.worldClientInt1 > 0 || this.worldClientList1.size() > 0)) {
                ++integer2;
                if (this.worldClientInt1 == 0) {
                    if (this.worldClientIntArray2 != null) {
                        this.worldClientList5.add(this.worldClientIntArray2);
                    }
                    this.worldClientIntArray2 = (int[])this.worldClientList1.remove(this.worldClientList1.size() - 1);
                    this.worldClientInt1 = this.worldClientIntArray2[this.worldClientIntArray2.length - 1];
                }
                if (this.worldClientInt1 > this.worldClientIntArray2.length - 32) {
                    final int[] worldClientIntArray2 = this.worldClientIntArray2;
                    final int worldClientInt1 = this.worldClientInt1 - 1;
                    this.worldClientInt1 = worldClientInt1;
                    final int integer3 = worldClientIntArray2[worldClientInt1];
                    this.worldClientIntArray2[this.worldClientIntArray2.length - 1] = this.worldClientInt1;
                    this.worldClientList1.add(this.worldClientIntArray2);
                    this.worldClientIntArray2 = this.worldClientMethod1();
                    this.worldClientInt1 = 1;
                    this.worldClientIntArray2[0] = integer3;
                }
                else {
                    final int[] worldClientIntArray3 = this.worldClientIntArray2;
                    final int worldClientInt2 = this.worldClientInt1 - 1;
                    this.worldClientInt1 = worldClientInt2;
                    int integer3;
                    n = (integer3 = worldClientIntArray3[worldClientInt2]) % this.worldWidth;
                    final int n3 = integer3 / this.worldWidth % this.worldHeight;
                    final int n4 = integer3 / this.worldWidth / this.worldHeight % this.worldLength;
                    final byte[] worldClientByteArray2 = this.worldClientByteArray2;
                    final int n5 = integer3 >> 3;
                    worldClientByteArray2[n5] ^= (byte)(1 << (integer3 & 0x7));
                    integer3 = this.worldClientIntArray1[n + n4 * this.worldWidth];
                    int n6 = (n3 >= integer3) ? skylightSubtracted : 0;
                    final byte b = this.worldClientByteArray1[(n3 * this.worldLength + n4) * this.worldWidth + n];
                    int n7;
                    if ((n7 = Block.lightOpacity[b]) > 100) {
                        n6 = 0;
                    }
                    else if (n6 < 15) {
                        if ((n7 = n7) == 0) {
                            n7 = 1;
                        }
                        int n8;
                        if (n > 0 && (n8 = (this.blocks[(n3 * this.worldLength + n4) * this.worldWidth + (n - 1)] & 0xF) - n7) > n6) {
                            n6 = n8;
                        }
                        if (n < this.worldWidth - 1 && (n8 = (this.blocks[(n3 * this.worldLength + n4) * this.worldWidth + (n + 1)] & 0xF) - n7) > n6) {
                            n6 = n8;
                        }
                        if (n3 > 0 && (n8 = (this.blocks[((n3 - 1) * this.worldLength + n4) * this.worldWidth + n] & 0xF) - n7) > n6) {
                            n6 = n8;
                        }
                        if (n3 < this.worldHeight - 1 && (n8 = (this.blocks[((n3 + 1) * this.worldLength + n4) * this.worldWidth + n] & 0xF) - n7) > n6) {
                            n6 = n8;
                        }
                        if (n4 > 0 && (n8 = (this.blocks[(n3 * this.worldLength + (n4 - 1)) * this.worldWidth + n] & 0xF) - n7) > n6) {
                            n6 = n8;
                        }
                        if (n4 < this.worldLength - 1 && (n8 = (this.blocks[(n3 * this.worldLength + (n4 + 1)) * this.worldWidth + n] & 0xF) - n7) > n6) {
                            n6 = n8;
                        }
                    }
                    if (n6 < Block.lightValue[b]) {
                        n6 = Block.lightValue[b];
                    }
                    if ((n7 = (this.blocks[(n3 * this.worldLength + n4) * this.worldWidth + n] & 0xF)) == n6) {
                        continue;
                    }
                    this.blocks[(n3 * this.worldLength + n4) * this.worldWidth + n] = (byte)((this.blocks[(n3 * this.worldLength + n4) * this.worldWidth + n] & 0xF0) + n6);
                    if (n > 0 && (this.blocks[(n3 * this.worldLength + n4) * this.worldWidth + (n - 1)] & 0xF) != n6 - 1) {
                        final int n9 = n - 1 + n3 * this.worldWidth + n4 * this.worldWidth * this.worldHeight;
                        if ((this.worldClientByteArray2[n9 >> 3] & 1 << (n9 & 0x7)) == 0x0) {
                            final byte[] worldClientByteArray3 = this.worldClientByteArray2;
                            final int n10 = n9 >> 3;
                            worldClientByteArray3[n10] |= (byte)(1 << (n9 & 0x7));
                            this.worldClientIntArray2[this.worldClientInt1++] = n9;
                        }
                    }
                    if (n < this.worldWidth - 1 && (this.blocks[(n3 * this.worldLength + n4) * this.worldWidth + (n + 1)] & 0xF) != n6 - 1) {
                        final int n9 = n + 1 + n3 * this.worldWidth + n4 * this.worldWidth * this.worldHeight;
                        if ((this.worldClientByteArray2[n9 >> 3] & 1 << (n9 & 0x7)) == 0x0) {
                            final byte[] worldClientByteArray4 = this.worldClientByteArray2;
                            final int n11 = n9 >> 3;
                            worldClientByteArray4[n11] |= (byte)(1 << (n9 & 0x7));
                            this.worldClientIntArray2[this.worldClientInt1++] = n9;
                        }
                    }
                    if (n3 > 0 && (this.blocks[((n3 - 1) * this.worldLength + n4) * this.worldWidth + n] & 0xF) != n6 - 1) {
                        final int n9 = n + (n3 - 1) * this.worldWidth + n4 * this.worldWidth * this.worldHeight;
                        if ((this.worldClientByteArray2[n9 >> 3] & 1 << (n9 & 0x7)) == 0x0) {
                            final byte[] worldClientByteArray5 = this.worldClientByteArray2;
                            final int n12 = n9 >> 3;
                            worldClientByteArray5[n12] |= (byte)(1 << (n9 & 0x7));
                            this.worldClientIntArray2[this.worldClientInt1++] = n9;
                        }
                    }
                    if (n3 < this.worldHeight - 1 && (this.blocks[((n3 + 1) * this.worldLength + n4) * this.worldWidth + n] & 0xF) != n6 - 1) {
                        final int n9 = n + (n3 + 1) * this.worldWidth + n4 * this.worldWidth * this.worldHeight;
                        if ((this.worldClientByteArray2[n9 >> 3] & 1 << (n9 & 0x7)) == 0x0) {
                            final byte[] worldClientByteArray6 = this.worldClientByteArray2;
                            final int n13 = n9 >> 3;
                            worldClientByteArray6[n13] |= (byte)(1 << (n9 & 0x7));
                            this.worldClientIntArray2[this.worldClientInt1++] = n9;
                        }
                    }
                    if (n4 > 0 && (this.blocks[(n3 * this.worldLength + (n4 - 1)) * this.worldWidth + n] & 0xF) != n6 - 1) {
                        final int n9 = n + n3 * this.worldWidth + (n4 - 1) * this.worldWidth * this.worldHeight;
                        if ((this.worldClientByteArray2[n9 >> 3] & 1 << (n9 & 0x7)) == 0x0) {
                            final byte[] worldClientByteArray7 = this.worldClientByteArray2;
                            final int n14 = n9 >> 3;
                            worldClientByteArray7[n14] |= (byte)(1 << (n9 & 0x7));
                            this.worldClientIntArray2[this.worldClientInt1++] = n9;
                        }
                    }
                    if (n4 < this.worldLength - 1 && (this.blocks[(n3 * this.worldLength + (n4 + 1)) * this.worldWidth + n] & 0xF) != n6 - 1) {
                        final int n9 = n + n3 * this.worldWidth + (n4 + 1) * this.worldWidth * this.worldHeight;
                        if ((this.worldClientByteArray2[n9 >> 3] & 1 << (n9 & 0x7)) == 0x0) {
                            final byte[] worldClientByteArray8 = this.worldClientByteArray2;
                            final int n15 = n9 >> 3;
                            worldClientByteArray8[n15] |= (byte)(1 << (n9 & 0x7));
                            this.worldClientIntArray2[this.worldClientInt1++] = n9;
                        }
                    }
                    if (posX2 == -999) {
                        posX2 = n;
                        acceptCountdown2 = n;
                        blockID = n3;
                        k = n3;
                        l = n4;
                        metadata = n4;
                    }
                    if (n < posX2) {
                        posX2 = n;
                    }
                    else if (n > acceptCountdown2) {
                        acceptCountdown2 = n;
                    }
                    if (n3 > k) {
                        k = n3;
                    }
                    else if (n3 < blockID) {
                        blockID = n3;
                    }
                    if (n4 < l) {
                        l = n4;
                    }
                    else {
                        if (n4 <= metadata) {
                            continue;
                        }
                        metadata = n4;
                    }
                }
            }
            if (posX2 > -999) {
                this.worldClientList2.add(new WorldBlockPositionType(this, posX2, blockID, l, acceptCountdown2, k, metadata));
            }
            if (integer2 > 0) {}
        }
    }
    
    public final String skylightUpdatesGUI() {
        return new StringBuilder().append("").append(this.worldClientList3.size() + this.worldClientList2.size()).toString();
    }
}
